# coding: utf-8

"""
    FINBOURNE Workflow API

    FINBOURNE Technology  # noqa: E501

    The version of the OpenAPI document: 0.1.131
    Contact: info@finbourne.com
    Generated by: https://openapi-generator.tech
"""


try:
    from inspect import getfullargspec
except ImportError:
    from inspect import getargspec as getfullargspec
import pprint
import re  # noqa: F401
import six

from lusid_workflow.configuration import Configuration


class CreateTaskInstanceRequest(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
      required_map (dict): The key is attribute name
                           and the value is whether it is 'required' or 'optional'.
    """
    openapi_types = {
        'correlation_id': 'str'
    }

    attribute_map = {
        'correlation_id': 'correlationId'
    }

    required_map = {
        'correlation_id': 'optional'
    }

    def __init__(self, correlation_id=None, local_vars_configuration=None):  # noqa: E501
        """CreateTaskInstanceRequest - a model defined in OpenAPI"
        
        :param correlation_id:  An identifier to allow correlation across the application tier
        :type correlation_id: str

        """  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration.get_default_copy()
        self.local_vars_configuration = local_vars_configuration

        self._correlation_id = None
        self.discriminator = None

        self.correlation_id = correlation_id

    @property
    def correlation_id(self):
        """Gets the correlation_id of this CreateTaskInstanceRequest.  # noqa: E501

        An identifier to allow correlation across the application tier  # noqa: E501

        :return: The correlation_id of this CreateTaskInstanceRequest.  # noqa: E501
        :rtype: str
        """
        return self._correlation_id

    @correlation_id.setter
    def correlation_id(self, correlation_id):
        """Sets the correlation_id of this CreateTaskInstanceRequest.

        An identifier to allow correlation across the application tier  # noqa: E501

        :param correlation_id: The correlation_id of this CreateTaskInstanceRequest.  # noqa: E501
        :type correlation_id: str
        """
        if (self.local_vars_configuration.client_side_validation and
                correlation_id is not None and len(correlation_id) > 64):
            raise ValueError("Invalid value for `correlation_id`, length must be less than or equal to `64`")  # noqa: E501
        if (self.local_vars_configuration.client_side_validation and
                correlation_id is not None and len(correlation_id) < 36):
            raise ValueError("Invalid value for `correlation_id`, length must be greater than or equal to `36`")  # noqa: E501
        if (self.local_vars_configuration.client_side_validation and
                correlation_id is not None and not re.search(r'^[a-zA-Z0-9\-_]+$', correlation_id)):  # noqa: E501
            raise ValueError(r"Invalid value for `correlation_id`, must be a follow pattern or equal to `/^[a-zA-Z0-9\-_]+$/`")  # noqa: E501

        self._correlation_id = correlation_id

    def to_dict(self, serialize=False):
        """Returns the model properties as a dict"""
        result = {}

        def convert(x):
            if hasattr(x, "to_dict"):
                args = getfullargspec(x.to_dict).args
                if len(args) == 1:
                    return x.to_dict()
                else:
                    return x.to_dict(serialize)
            else:
                return x

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            attr = self.attribute_map.get(attr, attr) if serialize else attr
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: convert(x),
                    value
                ))
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], convert(item[1])),
                    value.items()
                ))
            else:
                result[attr] = convert(value)

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, CreateTaskInstanceRequest):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, CreateTaskInstanceRequest):
            return True

        return self.to_dict() != other.to_dict()
